# coding: utf-8

"""
    VMware Aria Automation Assembler / CMX Service API

    When using Kubernetes integration, deploy and manage Kubernetes clusters and namespaces. The APIs that list collections of resources also support OData like implementation. Below query params can be used across CMX entities.  Example:  1. `$orderby` - returns a result with the rows being sorted by the values of provided attribute.      ```/cmx/api/resources/tags?$orderby=name%20desc```  2. `$top`, `$skip` - `$top` returns the requested number of resources. Used with `$skip`, the client can skip a given number of resources.      ```/cmx/api/resources/tags?$expand=true&$top=10&$skip=2```  3. `page` and `$size` - page used in conjunction with `$size` helps in pagination of resources.      ```/cmx/api/resources/tags?$expand=true&page=0&$size=5```  4. `$filter` - `$filter` returns a subset of resources that satisfy the given predicate expression.      ```     /cmx/api/resources/tags?$filter=startswith(name, 'K8S')   # noqa: E501

    OpenAPI spec version: 2019-09-12
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class VirtualMachineClass(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'api_version': 'str',
        'kind': 'str',
        'metadata': 'CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata',
        'spec': 'CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedSpec'
    }

    attribute_map = {
        'api_version': 'apiVersion',
        'kind': 'kind',
        'metadata': 'metadata',
        'spec': 'spec'
    }

    def __init__(self, api_version=None, kind=None, metadata=None, spec=None):  # noqa: E501
        """VirtualMachineClass - a model defined in Swagger"""  # noqa: E501
        self._api_version = None
        self._kind = None
        self._metadata = None
        self._spec = None
        self.discriminator = None
        if api_version is not None:
            self.api_version = api_version
        if kind is not None:
            self.kind = kind
        if metadata is not None:
            self.metadata = metadata
        if spec is not None:
            self.spec = spec

    @property
    def api_version(self):
        """Gets the api_version of this VirtualMachineClass.  # noqa: E501


        :return: The api_version of this VirtualMachineClass.  # noqa: E501
        :rtype: str
        """
        return self._api_version

    @api_version.setter
    def api_version(self, api_version):
        """Sets the api_version of this VirtualMachineClass.


        :param api_version: The api_version of this VirtualMachineClass.  # noqa: E501
        :type: str
        """

        self._api_version = api_version

    @property
    def kind(self):
        """Gets the kind of this VirtualMachineClass.  # noqa: E501


        :return: The kind of this VirtualMachineClass.  # noqa: E501
        :rtype: str
        """
        return self._kind

    @kind.setter
    def kind(self, kind):
        """Sets the kind of this VirtualMachineClass.


        :param kind: The kind of this VirtualMachineClass.  # noqa: E501
        :type: str
        """

        self._kind = kind

    @property
    def metadata(self):
        """Gets the metadata of this VirtualMachineClass.  # noqa: E501


        :return: The metadata of this VirtualMachineClass.  # noqa: E501
        :rtype: CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata
        """
        return self._metadata

    @metadata.setter
    def metadata(self, metadata):
        """Sets the metadata of this VirtualMachineClass.


        :param metadata: The metadata of this VirtualMachineClass.  # noqa: E501
        :type: CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedMetadata
        """

        self._metadata = metadata

    @property
    def spec(self):
        """Gets the spec of this VirtualMachineClass.  # noqa: E501


        :return: The spec of this VirtualMachineClass.  # noqa: E501
        :rtype: CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedSpec
        """
        return self._spec

    @spec.setter
    def spec(self, spec):
        """Sets the spec of this VirtualMachineClass.


        :param spec: The spec of this VirtualMachineClass.  # noqa: E501
        :type: CmxapiresourcesvsphereendpointsendpointSelfLinkIdvirtualmachineclassesdescribedSpec
        """

        self._spec = spec

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(VirtualMachineClass, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, VirtualMachineClass):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
